﻿var Resources = {};
var DataConnectors = [];

Resources.ChartThemes = [{
    key: "charttheme-default", "values": [
        "#4472C4",
        "#ED7D31",
        "#A5A5A5",
        "#FFC000",
        "#5B9BD5",
        "#70AD47",
        "#264478",
        "#9E480E",
        "#636363",
        "#997300"]
}, {
    key: "charttheme-2", "values": [
        "#4472C4",
        "#A5A5A5",
        "#5B9BD5",
        "#264478",
        "#636363",
        "#255E91",
        "#698ED0",
        "#B7B7B7",
        "#7CAFDD",
        "#335AA1"
    ]
}, {
    key: "charttheme-3", "values": [
        "#ED7D31",
        "#FFC000",
        "#70AD47",
        "#9E480E",
        "#997300",
        "#43682B",
        "#F1975A",
        "#FFCD33",
        "#8CC168",
        "#D26012"
    ]
}, {
    key: "charttheme-4", "values": [
        "#70AD47",
        "#5B9BD5",
        "#FFC000",
        "#43682B",
        "#255E91",
        "#997300",
        "#8CC168",
        "#7CAFDD",
        "#FFCD33",
        "#5A8A39"
    ]
}, {
    key: "charttheme-5", "values": [
        "#9E5E9B",
        "#54849A",
        "#6AAC90",
        "#5F385D",
        "#324F5C",
        "#3C6B57",
        "#B27EB0",
        "#729EB2",
        "#88BDA6",
        "#7E4B7C"
    ]
}, {
    key: "charttheme-6", "values": [
        "#ACC995",
        "#8EBBD2",
        "#A18CD0",
        "#658B47",
        "#3C7897",
        "#583D94",
        "#BDD4AA",
        "#A5C9DB",
        "#B4A3D9",
        "#88B167"
    ]
}, {
    key: "charttheme-7", "values": [
        "#826276",
        "#D36F68",
        "#8CAA7E",
        "#4E3B47",
        "#92312B",
        "#526B47",
        "#9E7E92",
        "#DC8C86",
        "#A3BB98",
        "#684E5E"
    ]
}, {
    key: "charttheme-8", "values": [
        "#A0988C",
        "#87795D",
        "#9CA383",
        "#635C51",
        "#514938",
        "#60654B",
        "#B3ADA3",
        "#A39579",
        "#B0B59C",
        "#837A6D"
    ]
}
];


class PfFwk {

    #flags = "ANIMATIONS;SLIDERS;POPUPS";
    #isInitialized = false;
    #searchNoResultText = "";

    hasFlag(val) {
        return this.#flags.indexOf(val) >= 0;
    }

    overrideFlags(value) {
        this.#flags = value;
    }

    get appVersion() {
        return "1.0.0.0";
    }

    get pageLanguage() {
        return document.getElementsByTagName("html")[0].getAttribute("lang");
    }

    getPartById(id) {
        if (document.getElementById(id) == undefined) {
            return null;
        }
        return new Part(id);
    }

    #generateString(length) {
        const characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
        let result = '';
        const charactersLength = characters.length;
        for (let i = 0; i < length; i++) {
            result += characters.charAt(Math.floor(Math.random() * charactersLength));
        }

        return result;
    }

    #resizeHNavs() {

        $("nav.pfHNav").each(function () {

            let $this = $(this);
            let $label = $this.find("span");
            let overflowText = $this.find("del").text();

            let $itemsContainer = $this.children("ul");
            let menuWidth = $this.outerWidth();
            let itemsToMove = new Array();

            $itemsContainer.find("li").show();
            $(".overflowButton").remove();

            let childrenWidth = 0;
            $this.children().each(function () {
                let tagName = $(this).prop("tagName").toLowerCase();
                if (tagName != "ul") {
                    childrenWidth += $(this).outerWidth();
                }
            });

            let willOverflow = false;

            if ($this.find(".icon").is(":visible")) {
                return true;
            }

            $itemsContainer.children("li").each(function () {
                let $menuItem = $(this);
                let menuItemWidth = $menuItem.outerWidth();
                childrenWidth += menuItemWidth;

                $menuItem.data("cw", childrenWidth);

                if (childrenWidth >= menuWidth) {
                    willOverflow = true;
                }

            });

            if (willOverflow) {

                let $overflowButton = $("<li class='overflowButton'><a href='javascript:;' class='hNavHasItems'>" + overflowText + "</a></li>");
                $itemsContainer.append($overflowButton);
                let buttonSpace = $overflowButton.outerWidth();

                $itemsContainer.children("li").each(function () {
                    let $menuItem = $(this);
                    let cw = $menuItem.data("cw");
                    if (cw >= menuWidth - buttonSpace) {
                        itemsToMove.push($menuItem);
                    }
                });

                if (itemsToMove.length > 0) {

                    let $overflowMenu = $("<ul class='pfSubMenu'></ul>");
                    for (let i = 0; i < itemsToMove.length; i++) {
                        itemsToMove[i].hide();
                        $overflowMenu.append("<li>" + itemsToMove[i].html() + "</li>");
                    }
                    $overflowButton.append($overflowMenu);
                }
            }
        });
    }

    #initHNavs() {

        $(document).on("click", ".hNavHasItems", function () {
            let $menu = $(this).parent().children(".pfSubMenu");
            let currentState = $menu.is(":visible");

            $(".pfSubMenu").hide();
            $(this).closest(".pfSubMenu").show();

            $(".hNavHasItems.open").removeClass("open");

            if (currentState) {
                $menu.hide();
                $(this).removeClass("open");
            }
            else {
                $menu.show();
                $(this).addClass("open");
            }
        });

        $(document).on("click", "li.hasItems>span", function () {
            $(this).parent().toggleClass("open").toggleClass("close");
        });

        $(document).on("click", ".pfHNav a.icon", function () {
            let $this = $(this);
            let menu = $this.closest(".pfHNav");
            $this.find(".las").toggleClass("la-times").toggleClass("la-bars");
            menu.toggleClass("responsive");
        });

        $(document).on("click", ".menuSearchBoxActivatorButton", function () {
            let $this = $(this);
            let $container = $this.closest(".searchBox");
            let $menu = $this.closest(".pfHNav");
            let availableWidth = $menu.width();
            let inputWidth = availableWidth / 2;

            //$container.find("input").css("width", inputWidth + "px").focus();
            $(".searchBoxFieldTextbox").focus();
            $menu.addClass("searchOpened").find("ul").css("visibility", "hidden");
            $container.find(".searchBoxField").show();
            $this.hide();
        });

        $(document).on("click", ".searchBoxDiscard", function () {
            let $this = $(this);
            let $container = $this.closest(".searchBox");
            let $searchLink = $container.find(".menuSearchBoxActivatorButton");
            let $menu = $this.closest(".pfHNav");

            $menu.removeClass("searchOpened").find("ul").css("visibility", "visible");
            $container.find(".searchBoxField").hide();
            $searchLink.show();
        });

    }

    #initVNavs() {

        $(document).on("click", ".vNavOverflowButton", function () {
            $("body").append("<div class='pfVNavModalBg'></div>");
            let menu = $(this).parent().find("ul").html();
            let $modalMenu = $("<div class='pfVNavModalContent'></div>");
            $modalMenu.html(menu);
            $("html").addClass("fixed");
            $("body").append($modalMenu);
        });


        $(document).on("click", ".pfVNavModalBg", function () {
            $(".pfVNavModalBg, .pfVNavModalContent").remove();
            $("html").removeClass("fixed");
        });

        $(".currentPage").parents("li").removeClass("close").addClass("open");
    }

    #initTabs() {

        let instance = this;

        $(".pfTabs").each(function () {
            let $this = $(this);

            let $tabControlContent = $this.find(".tabsContent");
            let activeTabHeight = $tabControlContent.find(".tabActive").height();
            $tabControlContent.css({ height: activeTabHeight });
        });

        $(document).on("click", ".tabHeader", function () {
            let $this = $(this);

            if ($this.hasClass("headerActive")) return;

            let $tabControl = $this.closest(".pfTabs");
            let $tabControlContent = $tabControl.find(".tabsContent");

            let animationFade = $tabControl.hasClass("animation-fade") && instance.hasFlag("ANIMATIONS");
            let animationSlide = $tabControl.hasClass("animation-slide") && instance.hasFlag("ANIMATIONS");

            $this.closest(".pfTabs").find(".headerActive").removeClass("headerActive");
            $this.addClass("headerActive");
            let tabId = $this.data("tab");

            $this.closest(".pfTabs").find(".tabsContent .tabContent").each(function () {
                let $item = $(this);

                $item.css("display", "").css("opacity", "").css("margin-left", "").css("margin-right", "");

                if (animationFade) {
                    if ($item.hasClass("tabActive")) {
                        $item.fadeOut("fast", function () {
                            $(this).removeClass("tabActive");
                        });
                    }

                    if ($item.data("tab") == tabId) {
                        $item.delay(350).fadeIn("fast", function () {
                            $(this).addClass("tabActive");

                            $tabControlContent.animate({
                                height: $item.height()
                            }, "fast");
                        });
                    }

                } else if (animationSlide) {

                    if ($item.hasClass("tabActive")) {
                        $item.css({
                            left: "0px",
                            right: "0px",
                        }).animate({
                            opacity: 0,
                            left: "-25px",
                            right: "25px",
                        }, 375, "easeInOutExpo", function () {
                            $(this).removeClass("tabActive");
                        });
                    }

                    if ($item.data("tab") == tabId) {

                        $item.css({
                            left: "25px",
                            right: "-25px",
                            display: "block",
                            opacity: 0
                        }).animate({
                            opacity: 1,
                            left: "0px",
                            right: "0px"
                        }, 375, "easeInOutExpo", function () {
                            $(this).addClass("tabActive");

                            $tabControlContent.animate({
                                height: $item.height()
                            }, "fast");
                        });
                    }

                } else {

                    $item.removeClass("tabActive");

                    if ($item.data("tab") == tabId) {
                        $item.addClass("tabActive");

                        $tabControlContent.css({
                            height: $item.height()
                        });
                    }

                }

            });
        });

        $(document).on("click", ".tabHeaderOverflowButton", function () {

            let $menu = $(this).closest(".pfTabs").find(".tabHeaderOverflow");
            $menu.toggle();
            if ($menu.is(":visible")) {
                $menu.parent().find(".tabHeaderOverflowButton").html("<i class='las la-angle-up'></i>");
            }
            else {
                $menu.parent().find(".tabHeaderOverflowButton").html("<i class='las la-angle-down'></i>");
            }

        });
    }

    #resizeTabs() {

        $(".tabHeaderOverflow > .tabHeader").each(function () {
            let $item = $(this);
            let $headersContainer = $item.closest(".pfTabs").find(".tabsHeaders");
            $item.detach().appendTo($headersContainer);
            $item.closest(".tabsHeaders").find(".tabHeaderOverflowButton").hide();
        });


        $(".pfTabs").each(function () {

            let $overflowContainer = $(this).find(".tabHeaderOverflow");
            let $headersContainer = $(this).find(".tabsHeaders");
            let itemsToMove = new Array();
            let $overflowButton = $headersContainer.find(".tabHeaderOverflowButton");

            $overflowButton.detach().appendTo($headersContainer);
            $overflowContainer.detach().appendTo($headersContainer).hide();

            $(this).find(".tabsHeaders > .tabHeader").each(function () {
                let $item = $(this);
                let parentWidth = $item.parent().outerWidth() - 25;

                if ($item.position().left > parentWidth) {
                    $item.parent().find(".tabHeaderOverflowButton").show();
                    itemsToMove.push($item);
                }
                else if ($item.position().left + $item.outerWidth() > parentWidth) {
                    $item.parent().find(".tabHeaderOverflowButton").show();
                    itemsToMove.push($item);
                }
            });

            for (let i = 0; i < itemsToMove.length; i++) {
                $(itemsToMove[i]).detach().appendTo($overflowContainer);
            }
        });

    }

    // #region Search

    #initGlobalSearch() {

        let instance = this;
        $(document).on("keydown", ".searchBoxFieldTextbox", function (e) {
            if (e.keyCode == 13) {
                instance.#searchNoResultText = $(this).attr("data-noresulttext");
                PageFabric.search($(this).val().toLowerCase());
            }
        });
    }

    search(text) {

        switch (PageFabricConfig.globalSearchMode) {
            case "Json":
                this.#searchJsonData(text);
                break;
            case "Webservice":
                this.#searchWebService(text);
                break;
            default:
        }
    }

    #searchJsonData(text) {

        let config = PageFabricConfig.globalSearchLanguageFiles.find(el => el.lang.toLowerCase() == PageFabric.pageLanguage.toLowerCase());
        if (config == undefined) {
            console.warn("Lang not found.");
            return;
        }

        let instance = this;

        $.get(config.url, function (data) {

            let searchIndex = JSON.parse(data);
            let results = [];

            let regex = new RegExp('\\b' + text + '\\b');

            for (let item of searchIndex) {
                if (regex.test(item.title.toLowerCase())) {
                    results.push(item);
                } else if (regex.test(item.keywords.toLowerCase())) {
                    results.push(item);
                }
                else if (regex.test(item.description.toLowerCase())) {
                    results.push(item);
                }
            }

            instance.#renderSearchResults(results);

        }).fail(function () {
            console.warn("error....");
        });

    }

    #searchWebService(text) {

        let config = PageFabricConfig.globalSearchWebServiceURL;
        if (config == undefined) {
            console.warn("No global search service configuration found.");
            return;
        }

        let queryUrl = config + "?l=" + PageFabric.pageLanguage + "&q=" + text;

        $.get(queryUrl, function (data) {

            let results = JSON.parse(data);
            instance.#renderSearchResults(results);

        }).fail(function () {
            console.warn("Error while requesting custom search service");
        });

    }

    #renderSearchResults(results) {
        $(".searchBoxResults").remove();
        let availableWidth = $("header").width();
        let panelWidth = 800;
        if (availableWidth < 760) {
            panelWidth = availableWidth - 4;
        }

        let $resultsDiv = $("<div class='searchBoxResults'></div>").css("width", panelWidth + "px");
        $(".searchBox").append($resultsDiv);

        if (results.length == 0) {
            $resultsDiv.append("<p>" + this.#searchNoResultText + "</p>");
        } else {
            for (let item of results) {
                $resultsDiv.append("<a  class='searchBoxResultItem' href=\"" + item.url + "\"><strong>" + item.title + "</strong><br/>" + item.description + "</a>");
            }
        }
    }

    // #endregion

    // #region Charts

    buildCharts() {

        let instance = this;

        $(".pfChart").each(function () {
            let $this = $(this);
            let id = $this.attr("id");

            if (id == undefined) {
                id = instance.#generateString(5);
                $this.attr("id", id);
            }

            let jsonData = $this.find("data").text();
            let data = jQuery.parseJSON(jsonData);

            let p = new Part(id);
            p.renderChart(data);
        });

    }

    // #endregion

    // #region Sliders

    #buildSliders() {

        if (!this.hasFlag("SLIDERS")) {
            return false;
        }

        let instance = this;

        $(".pfSlider").each(function () {
            let $this = $(this);
            $this.find(".slNavBottom").empty();
            let slidesCount = $this.find(".slide").length;
            for (let i = 0; i < slidesCount; i++) {
                $this.find(".slNavBottom").append("<span class='slDots " + (i == 0 ? "active" : "") + "'><\/span>");
            }
            setTimeout(function () {
                instance.switchSliderSlide($this, true, true)
            }, 6000)
        });

        $(document).on("click", ".slNavLeft", function () {
            let $slider = $(this).closest(".pfSlider");
            instance.switchSliderSlide($slider, false, -1)
        });

        $(document).on("click", ".slNavRight", function () {
            let $slider = $(this).closest(".pfSlider");
            instance.switchSliderSlide($slider, false, 1)
        });
    }

    switchSliderSlide($slider, autoswitch, step) {

        let instance = this;

        let animationFade = $slider.hasClass("animation-fade") && instance.hasFlag("ANIMATIONS");
        let animationSlide = $slider.hasClass("animation-slide") && instance.hasFlag("ANIMATIONS");

        let slidesCount = $slider.find(".slide").length - 1;
        let currentSlideIndex = $slider.find(".slide.active").index();

        if (isNaN(currentSlideIndex))
            currentSlideIndex = 0;

        if (currentSlideIndex <= slidesCount) {
            currentSlideIndex = currentSlideIndex + step;

            if (currentSlideIndex < 0) {
                currentSlideIndex = slidesCount;
            }

            if (currentSlideIndex > slidesCount) {
                currentSlideIndex = 0;
            }

        } else {
            currentSlideIndex = 0;
        }


        if (animationFade) {

            $slider.find(".slide.active").fadeOut("fast", function () {
                $(this).removeClass("active");
            });

            $slider.find(".slide").eq(currentSlideIndex).fadeIn("fast", function () {
                $(this).addClass("active");
            });

        } else if (animationSlide) {



            $slider.find(".slide.active").css({
                left: "0px",
                right: "0px",
            }).animate({
                opacity: 0,
                left: "-25px",
                right: "25px",
            }, 375, "easeInOutExpo", function () {
                $(this).removeClass("active");
            });


            $slider.find(".slide").eq(currentSlideIndex).css({
                left: "25px",
                right: "-25px",
                display: "block",
                opacity: 0
            }).animate({
                opacity: 1,
                left: "0px",
                right: "0px"
            }, 375, "easeInOutExpo", function () {
                $(this).addClass("active");
            });


        } else {
            $slider.find(".slide").removeClass("active").eq(currentSlideIndex).addClass("active");
        }

        $slider.find(".slNavBottom .slDots").removeClass("active").eq(currentSlideIndex).addClass("active");

        if (autoswitch) {
            setTimeout(function () {
                instance.switchSliderSlide($slider, autoswitch, +1)
            }, 6000);
        }


    }

    // #endregion

    #buildAccordions() {

        $(document).on("click", ".acHeader", function () {
            let $this = $(this);
            if ($this.hasClass("active")) return;

            let $acControl = $this.closest(".pfAcordions");
            $acControl.find(".pfAcordion").each(function () {
                let $ac = $(this);
                $ac.removeClass("active").find(".acHeader").removeClass("active");
            });

            $this.addClass("active").closest(".pfAcordion").toggleClass("active");
        });

    }

    refreshAllDataSources() {
        let c = 0;
        let allParts = document.getElementsByClassName("isDataBound");
        for (let part of allParts) {

            if (part.id == undefined || part.id == "") {
                part.id = "part_" + c;
            }

            let partObject = new Part(part.id);
            partObject.updateDataSource();
            c++;
        }
    }

    openFlyoutWithURL(url, width) {

        if (!this.hasFlag("POPUPS")) {
            return;
        }

        if (url == undefined) {
            console.warn("URL was not provided");
            return;
        }

        if (width == undefined) {
            console.warn("Size was not provided");
            return;
        }

        var $layer = $("<div class='pfPopupLayer'></div>");
        var $popup = $("<div class='pfFlyoutContainer' style=\"width:" + width + "; height:100%\"><iframe frameborder=0 src='" + url + "' width='100%' height='100%'></div>");

        $("body").append($layer);
        $("body").append($popup);

        //let top = $(window).height() / 2 - $(".pfFlyoutContainer").height() / 2 + "px";
        //let left = $(window).width() / 2 - $(".pfFlyoutContainer").width() / 2 + "px";
        //$(".pfFlyoutContainer").css("top", top).css("left", left);
    }

    openPopupWithURL(url, width, height) {

        if (!this.hasFlag("POPUPS")) {
            return;
        }

        if (url == undefined) {
            console.warn("URL was not provided");
            return;
        }

        if (width == undefined || height == undefined) {
            console.warn("Size was not provided");
            return;
        }

        var $layer = $("<div class='pfPopupLayer'></div>");
        var $popup = $("<div class='pfPopupContainer' style=\"width:" + width + "; height:" + height + "\"><iframe frameborder=0 src='" + url + "' width='100%' height='100%'></div>");

        $("body").append($layer);
        $("body").append($popup);

        let top = $(window).height() / 2 - $(".pfPopupContainer").height() / 2 + "px";
        let left = $(window).width() / 2 - $(".pfPopupContainer").width() / 2 + "px";
        $(".pfPopupContainer").css("top", top).css("left", left);
    }

    init() {

        if (this.#isInitialized) {
            return false;
        }

        this.#initTabs();
        this.#resizeTabs();
        this.#initHNavs();
        this.#initVNavs();
        this.buildCharts();
        this.#buildSliders();
        this.#buildAccordions();
        this.#resizeHNavs();
        this.#initGlobalSearch();

        this.refreshAllDataSources();

        let instance = this;

        $(window).resize(function () {
            instance.#resizeTabs();
            instance.#resizeHNavs();
        });

        $(document).on("click", "body", function (e) {
            let $e = $(e.target);

            $(".searchBoxResults").remove();

            if ($e.closest(".pfHNav").length > 0) return;
            $(".pfSubMenu").hide();
            $(".hNavHasItems.open").removeClass("open");
        });

        $(document).on("click", ".pfPopupLayer", function () {
            $(".pfPopupLayer").remove();
            $(".pfPopupContainer").remove();
            $(".pfFlyoutContainer").remove();
        });

        this.#isInitialized = true;

        return true;
    }
}

class Part {

    #clientId
    #control

    constructor(id) {
        this.#clientId = id;
        this.#control = $("#" + id);
    }

    get clientId() {
        return this.#clientId;
    }

    get text() {
        return this.#control.text();
    }

    get html() {
        return this.#control.html();
    }

    set text(val) {
        return this.#control.text(val);
    }

    set html(val) {
        return this.#control.html(val);
    }

    get value() {

        let $input = this.#control.find("input");
        if ($input.length == 1) {
            return $input.val();
        }

        let $select = this.#control.find("select");
        if ($select.length == 1) {
            return $select.val();
        }

        let $textarea = this.#control.find("textarea");
        if ($textarea.length == 1) {
            return $textarea.val();
        }

        return this.#control.val();
    }

    set value(val) {

        let $input = this.#control.find("input");
        if ($input.length == 1) {
            $input.val(val);
            return true;
        }

        let $select = this.#control.find("select");
        if ($select.length == 1) {
            $select.val(val);
            return true;
        }

        let $textarea = this.#control.find("textarea");
        if ($textarea.length == 1) {
            $textarea.val(val);
            return true;
        }

        return false;
    }

    #internalPrepareChartRequest(datasource) {

        let canvas = this.#control.find("canvas")[0];

        var ctx = canvas.getContext('2d');

        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.font = "14px 'Segoe UI', 'Sans Serif' ";
        ctx.fillText('Please wait...', 10, 10);

        this.#requestJsonData(datasource).then((itemsSource) => {

            let bindingLabelField = this.#control.attr("data-bindinglabelfield");
            let bindingValueField = this.#control.attr("data-bindingvaluefield");

            //let jsonData = instance.#control.find("data").text();
            //let dataObj = jQuery.parseJSON(jsonData);

            //dataObj.labels = new Array();
            //dataObj.datasets[0].data = new Array();

            let dobj = {}
            dobj.labels = [];
            dobj.datasets = [{ label: "", data: [], backgroundColor: [], borderColor: [], borderWidth: 2 }];

            for (let item of itemsSource.Items) {
                dobj.labels.push(item[bindingLabelField]);
                dobj.datasets[0].data.push(item[bindingValueField]);
            }

            this.renderChart(dobj);
        }).catch(function (error) {
            console.error('Error ', error)
        });

    }

    // #region Tables

    #renderDataboundTable(itemsSource) {

        let instance = this;
        let rowTemplate = instance.#control.data("rowTemplate");

        instance.#control.find("tr.template").remove();

        for (let item of itemsSource.Items) {
            let $newRow = $(rowTemplate);
            instance.#control.append($newRow);

            $newRow.find("*").each(function () {
                let dataBindField = $(this).attr("data-datasourcefield");

                if (dataBindField != undefined && dataBindField != null) {
                    if (item[dataBindField] == undefined || item[dataBindField] == null) {
                        console.warn("Datasource: Object does not contain a '" + dataBindField + "' field.");
                        return;
                    }
                    $(this).text(item[dataBindField])
                }
            })
        }

        if (instance.#control.attr("ondatasourceupdate") != undefined) {
            let fun = Function("" + instance.#control.attr("ondatasourceupdate") + "");
            fun();
        }
    }

    #internalPrepareTableRequest(datasource) {

        if (this.#control.data("rowTemplate") == undefined) {

            let $rowTemplate = this.#control.find("tr.template").first();

            let rowTemplate = $rowTemplate.prop('outerHTML');
            this.#control.data("rowTemplate", rowTemplate);
        }

        this.#control.find("tr.template").replaceWith("<tr class='template'><td colspan='99'>Please wait...</td></tr>");

        this.#requestJsonData(datasource).then((r) => {
            this.#renderDataboundTable(r);
        }).catch(function (error) {
            console.error('Error ', error)
        });
    }

    // #endregion

    #selectAccordionItem(idx) {

        let $acHeader = this.#control.find(".acHeader").eq(idx);

        if ($acHeader.hasClass("active")) return;

        this.#control.find(".pfAcordion").each(function () {
            let $ac = $(this);
            $ac.removeClass("active").find(".acHeader").removeClass("active");
        });
        $acHeader.addClass("active").closest(".pfAcordion").toggleClass("active");
    }

    #selectTabItem(idx) {
        this.#control.find(".headerActive").removeClass("headerActive");
        let $tab = this.#control.find(".tabHeader").eq(idx);
        $tab.addClass("headerActive");
        let tabId = $tab.data("tab");

        this.#control.find(".tabsContent .tabContent").each(function () {
            if ($(this).data("tab") == tabId) {
                $(this).addClass("tabActive");
            }
        });
    }

    #selectSliderItem(idx) {
        this.#control.find(".slide.active").removeClass("active");
        this.#control.find(".slide").eq(idx).addClass("active");
    }

    // #region Datasources

    /**
    * @param {string} datasource
    */
    updateDataSource(args) {

        let datasourceId = this.#control.attr("data-datasource");
        let datasource = null;

        if (datasourceId == undefined || datasourceId == "") {
            return false;
        }

        for (let dtsrc of DataConnectors) {
            if (dtsrc.Id == datasourceId) {
                datasource = dtsrc;
                break;
            }
        }

        if (datasource == null) {
            console.log("No datasource for this element.");
            return false;
        }

        if (args !== undefined) {
            datasource.Args = args;
        } else {
            datasource.Args = "";
        }

        let controlType = this.#control.prop("tagName");

        if (controlType.toLowerCase() == "table") {
            this.#internalPrepareTableRequest(datasource);
            return true;
        } else if (this.#control.hasClass("pfChart")) {
            this.#internalPrepareChartRequest(datasource);
            return true;
        }

        return false;
    }

    /**
    * @param {string} datasource
    */
    bindDataSource(datasource) {
        $("#" + this.#clientId).attr("data-datasource", datasource);
    }

    async #requestJsonData(datasource) {

        let requestUrl = datasource.URL;
        if (datasource.Args != "") {
            requestUrl = requestUrl + "?" + datasource.Args;
        }

        var request = new Request(requestUrl);

        const response = await fetch(request, { mode: 'cors' });

        if (response.ok) {
            const movies = await response.json();
            return movies;
        }

        throw "Datasource error '" + requestUrl + "' returned code " + response.status;
    }

    // #endregion    

    clear() {
        if (this.#control.hasClass("pfFormField")) {
            this.#control.find("input").val("");
            this.#control.find("textarea").val("");
        } else {
            this.#control.empty();
        }
    }

    play() {
        if (this.#control.prop("tagName").toLowerCase() != "video") {
            console.warn("Selected part is not a video");
            return false;
        }

        this.#control[0].play();
        return true;
    }

    pause() {
        if (this.#control.prop("tagName").toLowerCase() != "video") {
            console.warn("Selected part is not a video");
            return false;
        }

        this.#control[0].pause();
        return true;
    }

    stop() {
        if (this.#control.prop("tagName").toLowerCase() != "video") {
            console.warn("Selected part is not a video");
            return false;
        }

        this.#control[0].pause();
        this.#control[0].currentTime = 0;
        return true;
    }

    selectItem(idx) {

        if (this.#control.hasClass("pfAcordions")) {
            this.#selectAccordionItem(idx);
            return true;
        }
        if (this.#control.hasClass("pfTabs")) {
            this.#selectTabItem(idx);
            return true;
        }
        if (this.#control.hasClass("pfSlider")) {
            this.#selectSliderItem(idx);
            return true;
        }

        return false;
    }

    renderChart(data) {

        if (data === undefined || data == "") {
            throw "'data' cannot be empty.";
        }

        let $this = this.#control;

        let oldChartObj = $this.data("chartObject");
        if (oldChartObj) {
            oldChartObj.destroy();
        }

        let chartType = "bar";

        let displayLegend = true;
        let legendPosition = "right";
        if ($this.hasClass("legend-left"))
            legendPosition = "left";
        else if ($this.hasClass("legend-right"))
            legendPosition = "right";
        else if ($this.hasClass("legend-top"))
            legendPosition = "top";
        else if ($this.hasClass("legend-bottom"))
            legendPosition = "bottom";
        else if ($this.hasClass("legend-none"))
            displayLegend = false;



        if ($this.hasClass("chart-donut")) {
            chartType = "doughnut";
        }
        else if ($this.hasClass("chart-bar")) {
            chartType = "bar";
            displayLegend = false;
        }
        else if ($this.hasClass("chart-pie")) {
            chartType = "pie";
        }
        else if ($this.hasClass("chart-line")) {
            chartType = "line";
            displayLegend = false;
        }
        else if ($this.hasClass("chart-area")) {
            chartType = "area";
            displayLegend = false;
        }

        let canvas = $this.find("canvas");

        let chartThemeClass = "charttheme-default";
        let classList = $this[0].classList;

        for (let cl of classList) {
            if (cl.startsWith("charttheme-")) {
                chartThemeClass = cl;
            }
        }

        let chartTheme = Resources.ChartThemes.find(el => el.key == chartThemeClass);
        data.datasets[0].backgroundColor = chartTheme.values;

        if (chartType == "line") {
            data.datasets[0].borderWidth = 3;
            data.datasets[0].borderColor = chartTheme.values[0];
            data.datasets[0].backgroundColor = "transparent";
        }
        try {
            var chartObj = new Chart(canvas, {
                type: chartType,
                data: data,
                options: {
                    animation: {
                        duration: 0
                    },
                    legend: {
                        display: displayLegend,
                        position: legendPosition
                    },
                    layout: {
                        padding: {
                            left: 20,
                            right: 20,
                            top: 20,
                            bottom: 20
                        }
                    }
                }
            });
            $this.data("chartObject", chartObj);
        } catch {
            $this.html("<div class='pfManagedError'>Unable to load this chart. The Charts Package may have been disabled.</div>");
        }
    }
}

var PageFabric = new PfFwk();

$(document).ready(function () {
    PageFabric.init();

    if (typeof PageFunctions !== "undefined") {

        if (typeof PageFunctions.PageLoaded !== "undefined") {
            PageFunctions.PageLoaded();
        }

        if (typeof PageFunctions.CookieConsent !== "undefined") {
            PageFunctions.CookieConsent();
        } else {
            console.log("CookieConsent not activated.");
        }
    }

    if (typeof Prism !== "undefined") {
        Prism.hooks.add('before-highlight', function (env) {
            env.code = env.element.innerText;
        });
    } else {
        console.log("Prism Package not installed.");
    }

    if (typeof mediumZoom !== "undefined") {
        mediumZoom('.zoomable');
    } else {
        console.log("mediumZoom Package not installed.");
    }

});

